-- ==============================================================
-- RTL generated by Vitis HLS - High-Level Synthesis from C, C++ and OpenCL v2022.1 (64-bit)
-- Version: 2022.1
-- Copyright (C) Copyright 1986-2022 Xilinx, Inc. All Rights Reserved.
-- 
-- ===========================================================

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

entity cache_module is
port (
    ap_clk : IN STD_LOGIC;
    ap_rst : IN STD_LOGIC;
    ap_start : IN STD_LOGIC;
    ap_done : OUT STD_LOGIC;
    ap_idle : OUT STD_LOGIC;
    ap_ready : OUT STD_LOGIC;
    address : IN STD_LOGIC_VECTOR (31 downto 0);
    dirty : OUT STD_LOGIC;
    dirty_ap_vld : OUT STD_LOGIC;
    hit : OUT STD_LOGIC;
    hit_ap_vld : OUT STD_LOGIC;
    data : OUT STD_LOGIC_VECTOR (7 downto 0);
    data_ap_vld : OUT STD_LOGIC;
    updateSet : IN STD_LOGIC_VECTOR (7 downto 0);
    updateWay : IN STD_LOGIC_VECTOR (7 downto 0);
    newTag : IN STD_LOGIC_VECTOR (31 downto 0);
    updateTagValid : IN STD_LOGIC;
    newData_address0 : OUT STD_LOGIC_VECTOR (1 downto 0);
    newData_ce0 : OUT STD_LOGIC;
    newData_q0 : IN STD_LOGIC_VECTOR (7 downto 0);
    updateDataValid : IN STD_LOGIC );
end;


architecture behav of cache_module is 
    attribute CORE_GENERATION_INFO : STRING;
    attribute CORE_GENERATION_INFO of behav : architecture is
    "cache_module_cache_module,hls_ip_2022_1,{HLS_INPUT_TYPE=cxx,HLS_INPUT_FLOAT=0,HLS_INPUT_FIXED=0,HLS_INPUT_PART=xc7z020-clg400-1,HLS_INPUT_CLOCK=10.000000,HLS_INPUT_ARCH=others,HLS_SYN_CLOCK=7.793600,HLS_SYN_LAT=18,HLS_SYN_TPT=none,HLS_SYN_MEM=0,HLS_SYN_DSP=0,HLS_SYN_FF=301,HLS_SYN_LUT=823,HLS_VERSION=2022_1}";
    constant ap_const_logic_1 : STD_LOGIC := '1';
    constant ap_const_logic_0 : STD_LOGIC := '0';
    constant ap_ST_fsm_state1 : STD_LOGIC_VECTOR (8 downto 0) := "000000001";
    constant ap_ST_fsm_state2 : STD_LOGIC_VECTOR (8 downto 0) := "000000010";
    constant ap_ST_fsm_state3 : STD_LOGIC_VECTOR (8 downto 0) := "000000100";
    constant ap_ST_fsm_state4 : STD_LOGIC_VECTOR (8 downto 0) := "000001000";
    constant ap_ST_fsm_state5 : STD_LOGIC_VECTOR (8 downto 0) := "000010000";
    constant ap_ST_fsm_state6 : STD_LOGIC_VECTOR (8 downto 0) := "000100000";
    constant ap_ST_fsm_state7 : STD_LOGIC_VECTOR (8 downto 0) := "001000000";
    constant ap_ST_fsm_state8 : STD_LOGIC_VECTOR (8 downto 0) := "010000000";
    constant ap_ST_fsm_state9 : STD_LOGIC_VECTOR (8 downto 0) := "100000000";
    constant ap_const_lv32_0 : STD_LOGIC_VECTOR (31 downto 0) := "00000000000000000000000000000000";
    constant ap_const_boolean_1 : BOOLEAN := true;
    constant ap_const_lv1_1 : STD_LOGIC_VECTOR (0 downto 0) := "1";
    constant ap_const_lv32_2 : STD_LOGIC_VECTOR (31 downto 0) := "00000000000000000000000000000010";
    constant ap_const_lv32_3 : STD_LOGIC_VECTOR (31 downto 0) := "00000000000000000000000000000011";
    constant ap_const_lv32_4 : STD_LOGIC_VECTOR (31 downto 0) := "00000000000000000000000000000100";
    constant ap_const_lv32_6 : STD_LOGIC_VECTOR (31 downto 0) := "00000000000000000000000000000110";
    constant ap_const_lv32_7 : STD_LOGIC_VECTOR (31 downto 0) := "00000000000000000000000000000111";
    constant ap_const_lv32_8 : STD_LOGIC_VECTOR (31 downto 0) := "00000000000000000000000000001000";
    constant ap_const_lv1_0 : STD_LOGIC_VECTOR (0 downto 0) := "0";
    constant ap_const_lv32_1 : STD_LOGIC_VECTOR (31 downto 0) := "00000000000000000000000000000001";
    constant ap_const_lv8_0 : STD_LOGIC_VECTOR (7 downto 0) := "00000000";
    constant ap_const_lv8_F : STD_LOGIC_VECTOR (7 downto 0) := "00001111";
    constant ap_const_lv32_5 : STD_LOGIC_VECTOR (31 downto 0) := "00000000000000000000000000000101";
    constant ap_const_lv5_0 : STD_LOGIC_VECTOR (4 downto 0) := "00000";
    constant ap_const_lv3_0 : STD_LOGIC_VECTOR (2 downto 0) := "000";
    constant ap_const_lv32_1F : STD_LOGIC_VECTOR (31 downto 0) := "00000000000000000000000000011111";
    constant ap_const_lv2_0 : STD_LOGIC_VECTOR (1 downto 0) := "00";
    constant ap_const_lv6_4 : STD_LOGIC_VECTOR (5 downto 0) := "000100";
    constant ap_const_lv32_1D : STD_LOGIC_VECTOR (31 downto 0) := "00000000000000000000000000011101";
    constant ap_const_lv32_1E : STD_LOGIC_VECTOR (31 downto 0) := "00000000000000000000000000011110";
    constant ap_const_boolean_0 : BOOLEAN := false;

    signal ap_CS_fsm : STD_LOGIC_VECTOR (8 downto 0) := "000000001";
    attribute fsm_encoding : string;
    attribute fsm_encoding of ap_CS_fsm : signal is "none";
    signal ap_CS_fsm_state1 : STD_LOGIC;
    attribute fsm_encoding of ap_CS_fsm_state1 : signal is "none";
    signal cacheMemory_address0 : STD_LOGIC_VECTOR (2 downto 0);
    signal cacheMemory_ce0 : STD_LOGIC;
    signal cacheMemory_we0 : STD_LOGIC_VECTOR (7 downto 0);
    signal cacheMemory_d0 : STD_LOGIC_VECTOR (63 downto 0);
    signal cacheMemory_q0 : STD_LOGIC_VECTOR (63 downto 0);
    signal updateDataValid_read_read_fu_114_p2 : STD_LOGIC_VECTOR (0 downto 0);
    signal updateTagValid_read_read_fu_120_p2 : STD_LOGIC_VECTOR (0 downto 0);
    signal trunc_ln7_fu_212_p1 : STD_LOGIC_VECTOR (28 downto 0);
    signal trunc_ln7_reg_458 : STD_LOGIC_VECTOR (28 downto 0);
    signal add_ln9_fu_240_p2 : STD_LOGIC_VECTOR (5 downto 0);
    signal add_ln9_reg_463 : STD_LOGIC_VECTOR (5 downto 0);
    signal cacheMemory_addr_reg_468 : STD_LOGIC_VECTOR (2 downto 0);
    signal or_ln11_fu_290_p2 : STD_LOGIC_VECTOR (5 downto 0);
    signal or_ln11_reg_473 : STD_LOGIC_VECTOR (5 downto 0);
    signal ap_CS_fsm_state3 : STD_LOGIC;
    attribute fsm_encoding of ap_CS_fsm_state3 : signal is "none";
    signal lshr_ln1_reg_478 : STD_LOGIC_VECTOR (2 downto 0);
    signal ap_CS_fsm_state4 : STD_LOGIC;
    attribute fsm_encoding of ap_CS_fsm_state4 : signal is "none";
    signal trunc_ln15_2_fu_334_p1 : STD_LOGIC_VECTOR (28 downto 0);
    signal trunc_ln15_2_reg_483 : STD_LOGIC_VECTOR (28 downto 0);
    signal cacheMemory_addr_1_reg_488 : STD_LOGIC_VECTOR (2 downto 0);
    signal ap_CS_fsm_state5 : STD_LOGIC;
    attribute fsm_encoding of ap_CS_fsm_state5 : signal is "none";
    signal tmp_2_reg_493 : STD_LOGIC_VECTOR (0 downto 0);
    signal ap_CS_fsm_state7 : STD_LOGIC;
    attribute fsm_encoding of ap_CS_fsm_state7 : signal is "none";
    signal grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_ap_return : STD_LOGIC_VECTOR (0 downto 0);
    signal targetBlock_reg_498 : STD_LOGIC_VECTOR (0 downto 0);
    signal ap_CS_fsm_state8 : STD_LOGIC;
    attribute fsm_encoding of ap_CS_fsm_state8 : signal is "none";
    signal grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_ap_start : STD_LOGIC;
    signal grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_ap_done : STD_LOGIC;
    signal grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_ap_idle : STD_LOGIC;
    signal grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_ap_ready : STD_LOGIC;
    signal grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_newData_address0 : STD_LOGIC_VECTOR (1 downto 0);
    signal grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_newData_ce0 : STD_LOGIC;
    signal grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_cacheMemory_address0 : STD_LOGIC_VECTOR (2 downto 0);
    signal grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_cacheMemory_ce0 : STD_LOGIC;
    signal grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_cacheMemory_we0 : STD_LOGIC_VECTOR (7 downto 0);
    signal grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_cacheMemory_d0 : STD_LOGIC_VECTOR (63 downto 0);
    signal grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_ap_start : STD_LOGIC;
    signal grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_ap_done : STD_LOGIC;
    signal grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_ap_idle : STD_LOGIC;
    signal grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_ap_ready : STD_LOGIC;
    signal grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_cacheMemory_load_2_out : STD_LOGIC_VECTOR (63 downto 0);
    signal grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_cacheMemory_load_2_out_ap_vld : STD_LOGIC;
    signal grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_cacheMemory_address0 : STD_LOGIC_VECTOR (2 downto 0);
    signal grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_cacheMemory_ce0 : STD_LOGIC;
    signal grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_ap_start_reg : STD_LOGIC := '0';
    signal grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_ap_start_reg : STD_LOGIC := '0';
    signal cacheMemory_load_2_loc_fu_110 : STD_LOGIC_VECTOR (63 downto 0);
    signal zext_ln9_fu_256_p1 : STD_LOGIC_VECTOR (63 downto 0);
    signal zext_ln15_fu_337_p1 : STD_LOGIC_VECTOR (63 downto 0);
    signal ap_CS_fsm_state9 : STD_LOGIC;
    attribute fsm_encoding of ap_CS_fsm_state9 : signal is "none";
    signal ap_CS_fsm_state2 : STD_LOGIC;
    attribute fsm_encoding of ap_CS_fsm_state2 : signal is "none";
    signal zext_ln10_fu_285_p1 : STD_LOGIC_VECTOR (63 downto 0);
    signal ap_CS_fsm_state6 : STD_LOGIC;
    attribute fsm_encoding of ap_CS_fsm_state6 : signal is "none";
    signal zext_ln17_fu_364_p1 : STD_LOGIC_VECTOR (63 downto 0);
    signal trunc_ln9_fu_216_p1 : STD_LOGIC_VECTOR (0 downto 0);
    signal trunc_ln9_1_fu_228_p1 : STD_LOGIC_VECTOR (2 downto 0);
    signal shl_ln9_1_fu_232_p3 : STD_LOGIC_VECTOR (5 downto 0);
    signal shl_ln9_fu_220_p3 : STD_LOGIC_VECTOR (5 downto 0);
    signal lshr_ln9_fu_246_p4 : STD_LOGIC_VECTOR (2 downto 0);
    signal tmp_3_fu_261_p4 : STD_LOGIC_VECTOR (29 downto 0);
    signal and_ln_fu_271_p3 : STD_LOGIC_VECTOR (31 downto 0);
    signal or_ln10_fu_279_p2 : STD_LOGIC_VECTOR (31 downto 0);
    signal trunc_ln15_fu_296_p1 : STD_LOGIC_VECTOR (0 downto 0);
    signal trunc_ln15_1_fu_307_p1 : STD_LOGIC_VECTOR (2 downto 0);
    signal shl_ln15_2_fu_310_p3 : STD_LOGIC_VECTOR (5 downto 0);
    signal shl_ln15_1_fu_299_p3 : STD_LOGIC_VECTOR (5 downto 0);
    signal add_ln15_fu_318_p2 : STD_LOGIC_VECTOR (5 downto 0);
    signal tmp_1_fu_341_p3 : STD_LOGIC_VECTOR (0 downto 0);
    signal tmp_fu_349_p4 : STD_LOGIC_VECTOR (31 downto 0);
    signal or_ln16_fu_358_p2 : STD_LOGIC_VECTOR (31 downto 0);
    signal tmp_9_fu_380_p4 : STD_LOGIC_VECTOR (1 downto 0);
    signal zext_ln23_cast_fu_389_p4 : STD_LOGIC_VECTOR (5 downto 0);
    signal zext_ln23_fu_399_p1 : STD_LOGIC_VECTOR (63 downto 0);
    signal lshr_ln23_fu_403_p2 : STD_LOGIC_VECTOR (63 downto 0);
    signal ap_NS_fsm : STD_LOGIC_VECTOR (8 downto 0);
    signal ap_ST_fsm_state1_blk : STD_LOGIC;
    signal ap_ST_fsm_state2_blk : STD_LOGIC;
    signal ap_ST_fsm_state3_blk : STD_LOGIC;
    signal ap_block_state4_on_subcall_done : BOOLEAN;
    signal ap_ST_fsm_state4_blk : STD_LOGIC;
    signal ap_ST_fsm_state5_blk : STD_LOGIC;
    signal ap_ST_fsm_state6_blk : STD_LOGIC;
    signal ap_ST_fsm_state7_blk : STD_LOGIC;
    signal ap_ST_fsm_state8_blk : STD_LOGIC;
    signal ap_ST_fsm_state9_blk : STD_LOGIC;
    signal ap_ce_reg : STD_LOGIC;

    component cache_module_cache_module_Pipeline_VITIS_LOOP_11_1 IS
    port (
        ap_clk : IN STD_LOGIC;
        ap_rst : IN STD_LOGIC;
        ap_start : IN STD_LOGIC;
        ap_done : OUT STD_LOGIC;
        ap_idle : OUT STD_LOGIC;
        ap_ready : OUT STD_LOGIC;
        newData_address0 : OUT STD_LOGIC_VECTOR (1 downto 0);
        newData_ce0 : OUT STD_LOGIC;
        newData_q0 : IN STD_LOGIC_VECTOR (7 downto 0);
        or_ln11 : IN STD_LOGIC_VECTOR (5 downto 0);
        cacheMemory_address0 : OUT STD_LOGIC_VECTOR (2 downto 0);
        cacheMemory_ce0 : OUT STD_LOGIC;
        cacheMemory_we0 : OUT STD_LOGIC_VECTOR (7 downto 0);
        cacheMemory_d0 : OUT STD_LOGIC_VECTOR (63 downto 0) );
    end component;


    component cache_module_cache_module_Pipeline_VITIS_LOOP_20_2 IS
    port (
        ap_clk : IN STD_LOGIC;
        ap_rst : IN STD_LOGIC;
        ap_start : IN STD_LOGIC;
        ap_done : OUT STD_LOGIC;
        ap_idle : OUT STD_LOGIC;
        ap_ready : OUT STD_LOGIC;
        bf_lshr_cast : IN STD_LOGIC_VECTOR (0 downto 0);
        trunc_ln7 : IN STD_LOGIC_VECTOR (28 downto 0);
        cacheMemory_load_2_out : OUT STD_LOGIC_VECTOR (63 downto 0);
        cacheMemory_load_2_out_ap_vld : OUT STD_LOGIC;
        cacheMemory_address0 : OUT STD_LOGIC_VECTOR (2 downto 0);
        cacheMemory_ce0 : OUT STD_LOGIC;
        cacheMemory_q0 : IN STD_LOGIC_VECTOR (63 downto 0);
        ap_return : OUT STD_LOGIC_VECTOR (0 downto 0) );
    end component;


    component cache_module_cacheMemory_RAM_AUTO_1R1W IS
    generic (
        DataWidth : INTEGER;
        AddressRange : INTEGER;
        AddressWidth : INTEGER );
    port (
        clk : IN STD_LOGIC;
        reset : IN STD_LOGIC;
        address0 : IN STD_LOGIC_VECTOR (2 downto 0);
        ce0 : IN STD_LOGIC;
        we0 : IN STD_LOGIC_VECTOR (7 downto 0);
        d0 : IN STD_LOGIC_VECTOR (63 downto 0);
        q0 : OUT STD_LOGIC_VECTOR (63 downto 0) );
    end component;



begin
    cacheMemory_U : component cache_module_cacheMemory_RAM_AUTO_1R1W
    generic map (
        DataWidth => 64,
        AddressRange => 8,
        AddressWidth => 3)
    port map (
        clk => ap_clk,
        reset => ap_rst,
        address0 => cacheMemory_address0,
        ce0 => cacheMemory_ce0,
        we0 => cacheMemory_we0,
        d0 => cacheMemory_d0,
        q0 => cacheMemory_q0);

    grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194 : component cache_module_cache_module_Pipeline_VITIS_LOOP_11_1
    port map (
        ap_clk => ap_clk,
        ap_rst => ap_rst,
        ap_start => grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_ap_start,
        ap_done => grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_ap_done,
        ap_idle => grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_ap_idle,
        ap_ready => grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_ap_ready,
        newData_address0 => grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_newData_address0,
        newData_ce0 => grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_newData_ce0,
        newData_q0 => newData_q0,
        or_ln11 => or_ln11_reg_473,
        cacheMemory_address0 => grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_cacheMemory_address0,
        cacheMemory_ce0 => grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_cacheMemory_ce0,
        cacheMemory_we0 => grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_cacheMemory_we0,
        cacheMemory_d0 => grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_cacheMemory_d0);

    grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203 : component cache_module_cache_module_Pipeline_VITIS_LOOP_20_2
    port map (
        ap_clk => ap_clk,
        ap_rst => ap_rst,
        ap_start => grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_ap_start,
        ap_done => grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_ap_done,
        ap_idle => grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_ap_idle,
        ap_ready => grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_ap_ready,
        bf_lshr_cast => tmp_2_reg_493,
        trunc_ln7 => trunc_ln7_reg_458,
        cacheMemory_load_2_out => grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_cacheMemory_load_2_out,
        cacheMemory_load_2_out_ap_vld => grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_cacheMemory_load_2_out_ap_vld,
        cacheMemory_address0 => grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_cacheMemory_address0,
        cacheMemory_ce0 => grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_cacheMemory_ce0,
        cacheMemory_q0 => cacheMemory_q0,
        ap_return => grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_ap_return);





    ap_CS_fsm_assign_proc : process(ap_clk)
    begin
        if (ap_clk'event and ap_clk =  '1') then
            if (ap_rst = '1') then
                ap_CS_fsm <= ap_ST_fsm_state1;
            else
                ap_CS_fsm <= ap_NS_fsm;
            end if;
        end if;
    end process;


    grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_ap_start_reg_assign_proc : process(ap_clk)
    begin
        if (ap_clk'event and ap_clk =  '1') then
            if (ap_rst = '1') then
                grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_ap_start_reg <= ap_const_logic_0;
            else
                if ((ap_const_logic_1 = ap_CS_fsm_state3)) then 
                    grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_ap_start_reg <= ap_const_logic_1;
                elsif ((grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_ap_ready = ap_const_logic_1)) then 
                    grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_ap_start_reg <= ap_const_logic_0;
                end if; 
            end if;
        end if;
    end process;


    grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_ap_start_reg_assign_proc : process(ap_clk)
    begin
        if (ap_clk'event and ap_clk =  '1') then
            if (ap_rst = '1') then
                grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_ap_start_reg <= ap_const_logic_0;
            else
                if ((ap_const_logic_1 = ap_CS_fsm_state7)) then 
                    grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_ap_start_reg <= ap_const_logic_1;
                elsif ((grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_ap_ready = ap_const_logic_1)) then 
                    grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_ap_start_reg <= ap_const_logic_0;
                end if; 
            end if;
        end if;
    end process;

    process (ap_clk)
    begin
        if (ap_clk'event and ap_clk = '1') then
            if (((updateDataValid_read_read_fu_114_p2 = ap_const_lv1_1) and (ap_const_logic_1 = ap_CS_fsm_state1))) then
                    add_ln9_reg_463(5 downto 3) <= add_ln9_fu_240_p2(5 downto 3);
                cacheMemory_addr_reg_468 <= zext_ln9_fu_256_p1(3 - 1 downto 0);
            end if;
        end if;
    end process;
    process (ap_clk)
    begin
        if (ap_clk'event and ap_clk = '1') then
            if ((ap_const_logic_1 = ap_CS_fsm_state5)) then
                cacheMemory_addr_1_reg_488 <= zext_ln15_fu_337_p1(3 - 1 downto 0);
            end if;
        end if;
    end process;
    process (ap_clk)
    begin
        if (ap_clk'event and ap_clk = '1') then
            if (((ap_const_logic_1 = ap_CS_fsm_state8) and (grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_cacheMemory_load_2_out_ap_vld = ap_const_logic_1))) then
                cacheMemory_load_2_loc_fu_110 <= grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_cacheMemory_load_2_out;
            end if;
        end if;
    end process;
    process (ap_clk)
    begin
        if (ap_clk'event and ap_clk = '1') then
            if (((updateTagValid_read_read_fu_120_p2 = ap_const_lv1_1) and (ap_const_logic_1 = ap_CS_fsm_state4))) then
                lshr_ln1_reg_478 <= add_ln15_fu_318_p2(5 downto 3);
                trunc_ln15_2_reg_483 <= trunc_ln15_2_fu_334_p1;
            end if;
        end if;
    end process;
    process (ap_clk)
    begin
        if (ap_clk'event and ap_clk = '1') then
            if ((ap_const_logic_1 = ap_CS_fsm_state3)) then
                    or_ln11_reg_473(5 downto 3) <= or_ln11_fu_290_p2(5 downto 3);
            end if;
        end if;
    end process;
    process (ap_clk)
    begin
        if (ap_clk'event and ap_clk = '1') then
            if ((ap_const_logic_1 = ap_CS_fsm_state8)) then
                targetBlock_reg_498 <= grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_ap_return;
            end if;
        end if;
    end process;
    process (ap_clk)
    begin
        if (ap_clk'event and ap_clk = '1') then
            if ((ap_const_logic_1 = ap_CS_fsm_state7)) then
                tmp_2_reg_493 <= address(29 downto 29);
            end if;
        end if;
    end process;
    process (ap_clk)
    begin
        if (ap_clk'event and ap_clk = '1') then
            if ((ap_const_logic_1 = ap_CS_fsm_state1)) then
                trunc_ln7_reg_458 <= trunc_ln7_fu_212_p1;
            end if;
        end if;
    end process;
    add_ln9_reg_463(2 downto 0) <= "000";
    or_ln11_reg_473(2 downto 0) <= "100";

    ap_NS_fsm_assign_proc : process (ap_start, ap_CS_fsm, ap_CS_fsm_state1, updateDataValid_read_read_fu_114_p2, updateTagValid_read_read_fu_120_p2, ap_CS_fsm_state4, ap_CS_fsm_state8, grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_ap_done, ap_block_state4_on_subcall_done)
    begin
        case ap_CS_fsm is
            when ap_ST_fsm_state1 => 
                if (((updateDataValid_read_read_fu_114_p2 = ap_const_lv1_0) and (ap_const_logic_1 = ap_CS_fsm_state1) and (ap_start = ap_const_logic_1))) then
                    ap_NS_fsm <= ap_ST_fsm_state4;
                elsif (((updateDataValid_read_read_fu_114_p2 = ap_const_lv1_1) and (ap_const_logic_1 = ap_CS_fsm_state1) and (ap_start = ap_const_logic_1))) then
                    ap_NS_fsm <= ap_ST_fsm_state2;
                else
                    ap_NS_fsm <= ap_ST_fsm_state1;
                end if;
            when ap_ST_fsm_state2 => 
                ap_NS_fsm <= ap_ST_fsm_state3;
            when ap_ST_fsm_state3 => 
                ap_NS_fsm <= ap_ST_fsm_state4;
            when ap_ST_fsm_state4 => 
                if (((updateTagValid_read_read_fu_120_p2 = ap_const_lv1_0) and (ap_const_boolean_0 = ap_block_state4_on_subcall_done) and (ap_const_logic_1 = ap_CS_fsm_state4))) then
                    ap_NS_fsm <= ap_ST_fsm_state6;
                elsif (((updateTagValid_read_read_fu_120_p2 = ap_const_lv1_1) and (ap_const_boolean_0 = ap_block_state4_on_subcall_done) and (ap_const_logic_1 = ap_CS_fsm_state4))) then
                    ap_NS_fsm <= ap_ST_fsm_state5;
                else
                    ap_NS_fsm <= ap_ST_fsm_state4;
                end if;
            when ap_ST_fsm_state5 => 
                ap_NS_fsm <= ap_ST_fsm_state6;
            when ap_ST_fsm_state6 => 
                ap_NS_fsm <= ap_ST_fsm_state7;
            when ap_ST_fsm_state7 => 
                ap_NS_fsm <= ap_ST_fsm_state8;
            when ap_ST_fsm_state8 => 
                if (((ap_const_logic_1 = ap_CS_fsm_state8) and (grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_ap_done = ap_const_logic_1))) then
                    ap_NS_fsm <= ap_ST_fsm_state9;
                else
                    ap_NS_fsm <= ap_ST_fsm_state8;
                end if;
            when ap_ST_fsm_state9 => 
                ap_NS_fsm <= ap_ST_fsm_state1;
            when others =>  
                ap_NS_fsm <= "XXXXXXXXX";
        end case;
    end process;
    add_ln15_fu_318_p2 <= std_logic_vector(unsigned(shl_ln15_2_fu_310_p3) + unsigned(shl_ln15_1_fu_299_p3));
    add_ln9_fu_240_p2 <= std_logic_vector(unsigned(shl_ln9_1_fu_232_p3) + unsigned(shl_ln9_fu_220_p3));
    and_ln_fu_271_p3 <= (tmp_3_fu_261_p4 & ap_const_lv2_0);
    ap_CS_fsm_state1 <= ap_CS_fsm(0);
    ap_CS_fsm_state2 <= ap_CS_fsm(1);
    ap_CS_fsm_state3 <= ap_CS_fsm(2);
    ap_CS_fsm_state4 <= ap_CS_fsm(3);
    ap_CS_fsm_state5 <= ap_CS_fsm(4);
    ap_CS_fsm_state6 <= ap_CS_fsm(5);
    ap_CS_fsm_state7 <= ap_CS_fsm(6);
    ap_CS_fsm_state8 <= ap_CS_fsm(7);
    ap_CS_fsm_state9 <= ap_CS_fsm(8);

    ap_ST_fsm_state1_blk_assign_proc : process(ap_start)
    begin
        if ((ap_start = ap_const_logic_0)) then 
            ap_ST_fsm_state1_blk <= ap_const_logic_1;
        else 
            ap_ST_fsm_state1_blk <= ap_const_logic_0;
        end if; 
    end process;

    ap_ST_fsm_state2_blk <= ap_const_logic_0;
    ap_ST_fsm_state3_blk <= ap_const_logic_0;

    ap_ST_fsm_state4_blk_assign_proc : process(ap_block_state4_on_subcall_done)
    begin
        if ((ap_const_boolean_1 = ap_block_state4_on_subcall_done)) then 
            ap_ST_fsm_state4_blk <= ap_const_logic_1;
        else 
            ap_ST_fsm_state4_blk <= ap_const_logic_0;
        end if; 
    end process;

    ap_ST_fsm_state5_blk <= ap_const_logic_0;
    ap_ST_fsm_state6_blk <= ap_const_logic_0;
    ap_ST_fsm_state7_blk <= ap_const_logic_0;

    ap_ST_fsm_state8_blk_assign_proc : process(grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_ap_done)
    begin
        if ((grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_ap_done = ap_const_logic_0)) then 
            ap_ST_fsm_state8_blk <= ap_const_logic_1;
        else 
            ap_ST_fsm_state8_blk <= ap_const_logic_0;
        end if; 
    end process;

    ap_ST_fsm_state9_blk <= ap_const_logic_0;

    ap_block_state4_on_subcall_done_assign_proc : process(updateDataValid_read_read_fu_114_p2, grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_ap_done)
    begin
                ap_block_state4_on_subcall_done <= ((updateDataValid_read_read_fu_114_p2 = ap_const_lv1_1) and (grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_ap_done = ap_const_logic_0));
    end process;


    ap_done_assign_proc : process(ap_CS_fsm_state9)
    begin
        if ((ap_const_logic_1 = ap_CS_fsm_state9)) then 
            ap_done <= ap_const_logic_1;
        else 
            ap_done <= ap_const_logic_0;
        end if; 
    end process;


    ap_idle_assign_proc : process(ap_start, ap_CS_fsm_state1)
    begin
        if (((ap_const_logic_1 = ap_CS_fsm_state1) and (ap_start = ap_const_logic_0))) then 
            ap_idle <= ap_const_logic_1;
        else 
            ap_idle <= ap_const_logic_0;
        end if; 
    end process;


    ap_ready_assign_proc : process(ap_CS_fsm_state9)
    begin
        if ((ap_const_logic_1 = ap_CS_fsm_state9)) then 
            ap_ready <= ap_const_logic_1;
        else 
            ap_ready <= ap_const_logic_0;
        end if; 
    end process;


    cacheMemory_address0_assign_proc : process(ap_CS_fsm_state1, updateDataValid_read_read_fu_114_p2, cacheMemory_addr_reg_468, ap_CS_fsm_state4, cacheMemory_addr_1_reg_488, ap_CS_fsm_state5, ap_CS_fsm_state8, grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_cacheMemory_address0, grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_cacheMemory_address0, zext_ln9_fu_256_p1, zext_ln15_fu_337_p1, ap_CS_fsm_state2, ap_CS_fsm_state6)
    begin
        if ((ap_const_logic_1 = ap_CS_fsm_state6)) then 
            cacheMemory_address0 <= cacheMemory_addr_1_reg_488;
        elsif ((ap_const_logic_1 = ap_CS_fsm_state5)) then 
            cacheMemory_address0 <= zext_ln15_fu_337_p1(3 - 1 downto 0);
        elsif ((ap_const_logic_1 = ap_CS_fsm_state2)) then 
            cacheMemory_address0 <= cacheMemory_addr_reg_468;
        elsif ((ap_const_logic_1 = ap_CS_fsm_state1)) then 
            cacheMemory_address0 <= zext_ln9_fu_256_p1(3 - 1 downto 0);
        elsif ((ap_const_logic_1 = ap_CS_fsm_state8)) then 
            cacheMemory_address0 <= grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_cacheMemory_address0;
        elsif (((updateDataValid_read_read_fu_114_p2 = ap_const_lv1_1) and (ap_const_logic_1 = ap_CS_fsm_state4))) then 
            cacheMemory_address0 <= grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_cacheMemory_address0;
        else 
            cacheMemory_address0 <= "XXX";
        end if; 
    end process;


    cacheMemory_ce0_assign_proc : process(ap_start, ap_CS_fsm_state1, updateDataValid_read_read_fu_114_p2, ap_CS_fsm_state4, ap_CS_fsm_state5, ap_CS_fsm_state8, grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_cacheMemory_ce0, grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_cacheMemory_ce0, ap_CS_fsm_state2, ap_CS_fsm_state6)
    begin
        if (((ap_const_logic_1 = ap_CS_fsm_state6) or (ap_const_logic_1 = ap_CS_fsm_state2) or (ap_const_logic_1 = ap_CS_fsm_state5) or ((ap_const_logic_1 = ap_CS_fsm_state1) and (ap_start = ap_const_logic_1)))) then 
            cacheMemory_ce0 <= ap_const_logic_1;
        elsif ((ap_const_logic_1 = ap_CS_fsm_state8)) then 
            cacheMemory_ce0 <= grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_cacheMemory_ce0;
        elsif (((updateDataValid_read_read_fu_114_p2 = ap_const_lv1_1) and (ap_const_logic_1 = ap_CS_fsm_state4))) then 
            cacheMemory_ce0 <= grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_cacheMemory_ce0;
        else 
            cacheMemory_ce0 <= ap_const_logic_0;
        end if; 
    end process;


    cacheMemory_d0_assign_proc : process(updateDataValid_read_read_fu_114_p2, ap_CS_fsm_state4, grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_cacheMemory_d0, ap_CS_fsm_state2, zext_ln10_fu_285_p1, ap_CS_fsm_state6, zext_ln17_fu_364_p1)
    begin
        if ((ap_const_logic_1 = ap_CS_fsm_state6)) then 
            cacheMemory_d0 <= zext_ln17_fu_364_p1;
        elsif ((ap_const_logic_1 = ap_CS_fsm_state2)) then 
            cacheMemory_d0 <= zext_ln10_fu_285_p1;
        elsif (((updateDataValid_read_read_fu_114_p2 = ap_const_lv1_1) and (ap_const_logic_1 = ap_CS_fsm_state4))) then 
            cacheMemory_d0 <= grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_cacheMemory_d0;
        else 
            cacheMemory_d0 <= "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX";
        end if; 
    end process;


    cacheMemory_we0_assign_proc : process(updateDataValid_read_read_fu_114_p2, updateTagValid_read_read_fu_120_p2, ap_CS_fsm_state4, grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_cacheMemory_we0, ap_CS_fsm_state2, ap_CS_fsm_state6)
    begin
        if (((ap_const_logic_1 = ap_CS_fsm_state2) or ((updateTagValid_read_read_fu_120_p2 = ap_const_lv1_1) and (ap_const_logic_1 = ap_CS_fsm_state6)))) then 
            cacheMemory_we0 <= ap_const_lv8_F;
        elsif (((updateDataValid_read_read_fu_114_p2 = ap_const_lv1_1) and (ap_const_logic_1 = ap_CS_fsm_state4))) then 
            cacheMemory_we0 <= grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_cacheMemory_we0;
        else 
            cacheMemory_we0 <= ap_const_lv8_0;
        end if; 
    end process;

    data <= lshr_ln23_fu_403_p2(8 - 1 downto 0);

    data_ap_vld_assign_proc : process(targetBlock_reg_498, ap_CS_fsm_state9)
    begin
        if (((ap_const_logic_1 = ap_CS_fsm_state9) and (targetBlock_reg_498 = ap_const_lv1_0))) then 
            data_ap_vld <= ap_const_logic_1;
        else 
            data_ap_vld <= ap_const_logic_0;
        end if; 
    end process;

    dirty <= cacheMemory_load_2_loc_fu_110(1);

    dirty_ap_vld_assign_proc : process(targetBlock_reg_498, ap_CS_fsm_state9)
    begin
        if (((ap_const_logic_1 = ap_CS_fsm_state9) and (targetBlock_reg_498 = ap_const_lv1_0))) then 
            dirty_ap_vld <= ap_const_logic_1;
        else 
            dirty_ap_vld <= ap_const_logic_0;
        end if; 
    end process;

    grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_ap_start <= grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_ap_start_reg;
    grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_ap_start <= grp_cache_module_Pipeline_VITIS_LOOP_20_2_fu_203_ap_start_reg;

    hit_assign_proc : process(targetBlock_reg_498, ap_CS_fsm_state9)
    begin
        if ((ap_const_logic_1 = ap_CS_fsm_state9)) then
            if ((targetBlock_reg_498 = ap_const_lv1_1)) then 
                hit <= ap_const_logic_0;
            elsif ((targetBlock_reg_498 = ap_const_lv1_0)) then 
                hit <= ap_const_logic_1;
            else 
                hit <= 'X';
            end if;
        else 
            hit <= 'X';
        end if; 
    end process;


    hit_ap_vld_assign_proc : process(targetBlock_reg_498, ap_CS_fsm_state9)
    begin
        if ((((ap_const_logic_1 = ap_CS_fsm_state9) and (targetBlock_reg_498 = ap_const_lv1_1)) or ((ap_const_logic_1 = ap_CS_fsm_state9) and (targetBlock_reg_498 = ap_const_lv1_0)))) then 
            hit_ap_vld <= ap_const_logic_1;
        else 
            hit_ap_vld <= ap_const_logic_0;
        end if; 
    end process;

    lshr_ln23_fu_403_p2 <= std_logic_vector(shift_right(unsigned(cacheMemory_load_2_loc_fu_110),to_integer(unsigned('0' & zext_ln23_fu_399_p1(31-1 downto 0)))));
    lshr_ln9_fu_246_p4 <= add_ln9_fu_240_p2(5 downto 3);
    newData_address0 <= grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_newData_address0;
    newData_ce0 <= grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_194_newData_ce0;
    or_ln10_fu_279_p2 <= (ap_const_lv32_1 or and_ln_fu_271_p3);
    or_ln11_fu_290_p2 <= (ap_const_lv6_4 or add_ln9_reg_463);
    or_ln16_fu_358_p2 <= (tmp_fu_349_p4 or ap_const_lv32_1);
    shl_ln15_1_fu_299_p3 <= (trunc_ln15_fu_296_p1 & ap_const_lv5_0);
    shl_ln15_2_fu_310_p3 <= (trunc_ln15_1_fu_307_p1 & ap_const_lv3_0);
    shl_ln9_1_fu_232_p3 <= (trunc_ln9_1_fu_228_p1 & ap_const_lv3_0);
    shl_ln9_fu_220_p3 <= (trunc_ln9_fu_216_p1 & ap_const_lv5_0);
    tmp_1_fu_341_p3 <= cacheMemory_q0(31 downto 31);
    tmp_3_fu_261_p4 <= cacheMemory_q0(31 downto 2);
    tmp_9_fu_380_p4 <= address(31 downto 30);
    tmp_fu_349_p4 <= ((tmp_1_fu_341_p3 & trunc_ln15_2_reg_483) & ap_const_lv2_0);
    trunc_ln15_1_fu_307_p1 <= updateWay(3 - 1 downto 0);
    trunc_ln15_2_fu_334_p1 <= newTag(29 - 1 downto 0);
    trunc_ln15_fu_296_p1 <= updateSet(1 - 1 downto 0);
    trunc_ln7_fu_212_p1 <= address(29 - 1 downto 0);
    trunc_ln9_1_fu_228_p1 <= updateWay(3 - 1 downto 0);
    trunc_ln9_fu_216_p1 <= updateSet(1 - 1 downto 0);
    updateDataValid_read_read_fu_114_p2 <= (0=>updateDataValid, others=>'-');
    updateTagValid_read_read_fu_120_p2 <= (0=>updateTagValid, others=>'-');
    zext_ln10_fu_285_p1 <= std_logic_vector(IEEE.numeric_std.resize(unsigned(or_ln10_fu_279_p2),64));
    zext_ln15_fu_337_p1 <= std_logic_vector(IEEE.numeric_std.resize(unsigned(lshr_ln1_reg_478),64));
    zext_ln17_fu_364_p1 <= std_logic_vector(IEEE.numeric_std.resize(unsigned(or_ln16_fu_358_p2),64));
    zext_ln23_cast_fu_389_p4 <= ((ap_const_lv1_1 & tmp_9_fu_380_p4) & ap_const_lv3_0);
    zext_ln23_fu_399_p1 <= std_logic_vector(IEEE.numeric_std.resize(unsigned(zext_ln23_cast_fu_389_p4),64));
    zext_ln9_fu_256_p1 <= std_logic_vector(IEEE.numeric_std.resize(unsigned(lshr_ln9_fu_246_p4),64));
end behav;
